

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

DROP     PROCEDURE [dbo].[Pron_IngHE_Reserva]
GO

CREATE     PROCEDURE [dbo].[Pron_IngHE_Reserva]   @dia_inic datetime, @dia_fin datetime, @dia_reserv datetime, @mone int, @tasa_ext numeric(13,8)
AS

/*   Calcula ingreso de Hospedaje en RESERVAS, dentro un rango de fechas a base de la fecha de reservacion hacia el pasado */
begin

    Declare @Ing_Local numeric(15,2), @mese varchar(10), @ciclo datetime, @ing_reserva numeric(15,2)
    Declare @Tab_PREH TABLE	(id_rese		int, 
							 id_cont		int,
							 id_estado		int,
							 id_mone		int,
							 tasa			numeric(13,8),
							 fecha_ent		datetime,
							 fecha_sal		datetime,
							 fecha_reserv	datetime,
							 cant_habi		int,
							 precio_hab		money,
							 precio			numeric(18,2),
							 cantidad		tinyint,
							 nombre			varchar(40),
							 nomb_reserv	varchar(40),
							 nro_reserva	int,
							 fecha_anulada	datetime,
							 id_lres		int,
							 id_ralo		int,
							 id_agen		int,
							 tasa_fija		numeric(13,8),
							 cod_mone		char(3))


     
																/* CREA TABLA DE POSIBLES DATOS Pasado--Futuro */  
							
Insert into @Tab_PREH
select rese.id_rese, rese.id_cont, id_estado, cont.id_mone, tasa, fecha_ent=reau.fecha_desde, fecha_sal=reau.fecha_hasta, fecha_reserv, cant_habi,precio_hab,
	   precio, cantidad, nombre ,nomb_reserv, nro_reserva, fecha_anulada, lres.id_lres, lres.id_ralo, id_agen, tasa_fija, cod_mone
        from hoterese rese
        Inner Join Hotelres lres     on  rese.id_rese    = lres.id_rese 
        Inner Join Hotecont cont  on  rese.id_cont   = cont.id_cont
        Inner join Hotereau reau on lres.id_lres = reau.id_lres        
        Inner Join Siclamon  sicla on  cont.id_mone  = sicla.id_mone
        Where DateDiff(day, rese.fecha_ent, @dia_inic) <= 0 and
              DateDiff(day, rese.fecha_ent, @dia_fin) >= 0 and  
              rese.id_estado in(2,3,5)and
              reau.id_con0 in (select thab.id_con0 from hotethab thab )
union
select rese.id_rese, rese.id_cont, id_estado, cont.id_mone, tasa, fecha_ent=reau.fecha_desde, fecha_sal=reau.fecha_hasta, fecha_reserv, cant_habi,precio_hab,
	   precio, cantidad, nombre ,nomb_reserv, nro_reserva, fecha_anulada, lres.id_lres, lres.id_ralo, id_agen, tasa_fija, cod_mone
        from HOTEHRES rese
        Inner Join HOTEHLRE lres     on  rese.id_rese    = lres.id_rese 
        Inner Join Hotecont cont  on  rese.id_cont   = cont.id_cont
        Inner join HOTEHREAU reau on lres.id_lres = reau.id_lres        
        Inner Join Siclamon  sicla on  cont.id_mone  = sicla.id_mone
        Where DateDiff(day, rese.fecha_ent, @dia_inic) <= 0 and
              DateDiff(day, rese.fecha_ent, @dia_fin) >= 0 and  
              rese.id_estado in(2,3,5)and
              reau.id_con0 in (select thab.id_con0 from hotethab thab )
		order by fecha_reserv




																	/* CREA CONSULTA DATOS DE INGRESO DE HOSPEDAJE POR MES */  
																	
set @mese=LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)

while @mese <= (LEFT(year(@dia_fin),4)+Right('0'+left(month(@dia_fin),2),2)) 
  begin 
 
	--select @ciclo=LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)+Right('0'+left(day(@dia_inic),2),2)
	select @ciclo= (dateadd(d,-1,dateadd(m,1, CAST ((LEFT(year(LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)+Right('0'+left(day(@dia_inic),2),2)),4)
				   +Right('0'+left(month(LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)+Right('0'+left(day(@dia_inic),2),2)),2),2)+'01') as smalldatetime))))
	 
	set @ing_reserva=0
	while   @dia_inic <= @ciclo
		begin
    
			Select  @Ing_Local  = Coalesce(@Ing_Local,0) + Coalesce(Sum ( (precio*cantidad) * Case when id_mone ! = @mone
                                                                                     then @tasa_ext / COALESCE(tasa_fija, tasa)
                                                                                     else 1
                                                                                     end ) ,0.00) 
					from @Tab_PREH
					Where DATEDIFF(DAY, @dia_reserv, fecha_reserv)<=0 and
					DateDiff(day, fecha_ent, @dia_inic) >= 0 and
					DateDiff(day, @dia_inic, fecha_sal) > 0
			
			set @dia_inic=@dia_inic + 1  
			set @ing_reserva = @ing_reserva +  Coalesce(@Ing_Local,0)
			set @Ing_Local=0        
		end   	
		
																	/* CREA TABLA CON DATOS DE INGRESO DE HOSPEDAJE POR MES */ 
																	 
	
	
	Update HOTEDAIPG set ing_Reserva=Ing_Reserva+@ing_reserva
									where mes=MONTH(@ciclo) and fyear=YEAR(@ciclo)
									
	set @dia_inic =@dia_inic  
	set @mese = @mese + 1
	set @mese=LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)
	
  end 
end



